import Par._
import Prof._

object SpeedupMain extends App {
    def doTask(taskno:Int, n:Long) = {
        var i:Long = 0
        println("Starting T"+taskno+"...")
        while (i<n) {
            i += 1
            if (i%(n/10)==0) println("    - T"+taskno+" "+100*i/n+"%")
        }
        println("T"+taskno+" done.")
    }

    val n = 7e8.toLong

    println("--- Test sequenziale: ")
    val tseq = profila {
        //doTask(1, n)
        doTask(2, n)
        doTask(3, n /*+ n/2*/)
        //doTask(4, n)
    }._2

    println("--- Test parallelo: ")
    val tpar = profila {
        //doTask(1, n)
        par { doTask(2, n)       }
            { doTask(3, n /*+ n/2*/) }
        //doTask(4, n)
    }._2

    println("Speedup: "+tseq/tpar)
}
