object TreeMain extends App {

    def isPrime(n:Int) =
        n>1 && (2 to n/2)
                .forall(n % _ != 0)

    val t = Tree.buildComplete(10)(identity)
	
	println(t)

    println("Versione sequenziale:")
    val (v1,r1) = Prof.profila {
        t.count(isPrime)
    }

    println("Versione parallela:")
    val (v2,r2) = Prof.profila {
        t.countPar(isPrime)
    }

    println("Tempo sequenziale: " + r1 + " (ris: " + v1 + ")")
    println("Tempo parallelo: " + r2 + " (ris: " + v2 + ")")
    println("Speedup: "+r1/r2)
}
